#!/usr/bin/env python2
# This file is available at http://tu-dresden.de/zih/perf
#
# Copyright (c) 2014
# Technische Universitaet Dresden, Germany
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License version 2
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.


import time, sys, re
from otf import *

f=open("./trace")

otfname = "kerneltrace"

manager_cpu=OTF_FileManager_open(100)
manager_processes=OTF_FileManager_open(100)
global_wstream_cpu=OTF_WStream_open(otfname+"_cpu", 0, manager_cpu)
global_wstream_processes=OTF_WStream_open(otfname+"_processes", 0, manager_processes)
OTF_WStream_writeDefTimerResolution(global_wstream_cpu, 1000000000)
OTF_WStream_writeDefTimerResolution(global_wstream_processes, 1000000000)

# mapping process/cpu -> lpid
processes = {}

# mapping process/cpu -> (functionname -> lfid)
process_functions = {}

# streams for cpu
wstream_cpu = {}

#streams for processes
wstream_processes = {}
# start at 10000 the first 1 to 9999 is reserved for CPUs
lpid = 10000
lfid = 1

# stack depth mapping process/cpu -> depth
stack_depth = {}

wrote_data = {}

processes["Kernel"]=lpid
process_functions["Kernel"]={}
process_functions["Kernel"]["Unknown"]=lfid
OTF_WStream_writeDefFunctionGroup(global_wstream_processes, lpid, "Kernel")
OTF_WStream_writeDefFunction(global_wstream_processes, lfid, "Unknown", processes["Kernel"],  0)
OTF_WStream_writeDefFunctionGroup(global_wstream_cpu, lpid, "Unknown")
OTF_WStream_writeDefFunction(global_wstream_cpu, lfid, "Unknown", processes["Kernel"],  0)
lpid=lpid+1
lfid=lfid+1

# for cpu in cpus:


#processes["Unknown"]=lpid
#process_functions["Unknown"]={}
#process_functions["Unknown"]["Unknown"]=lfid
#lfid=lfid+1
#lpid=lpid+1

nr=0
first=True

timestamp=0
old_timestamp=0

last_file_line_location=-1

for line in f:
	
#	if last_file_line_location>-1:
#		file_lines[last_file_line_location]=files[cpu].readline()
#
#	min_timestamp=0
#	for cpu in cpus:
#		# find next timestamp
#		while
#		if line.strip().startswith("#"):
#			pass
#		if line.strip().startswith("-----"):
#			pass
#		elif line.find("Overruns")!=-1:
#			# TODO
#			print "Overrun at CPU%d",cpu
#
#		elif re.match(".+\|.+-.+\|.*\|.*",line):
#			ts=float(line[0:line.find("|")].strip())*1000000.0
#			timestamp=int(ts)
#			if (min_timestamp)
#			
#
#	line=file_lines[cpu]

	#############################################################
	#
	# Function enter/exit
	# Example:
	#  358.864139 |   1)  kworker-3203  |               |        get_cpu_iowait_time_us() {
	#############################################################


	if line.strip().startswith("#"):
		pass
	if line.strip().startswith("-----"):
		pass
	elif line.find("Overruns")!=-1:
		if line.find("Overruns: 0")!=-1:
			pass
		else:
			# TODO
			print line,
			pass
	elif re.match(".+\|.+-.+\|.*\|.*",line):

		# timestamp and conversion to us
		ts=float(line[0:line.find("|")].strip())*1000000000.0
		timestamp=int(ts)
		if timestamp<old_timestamp:
			print "Inconsistent timestamp"
			pass
		else:
			old_timestamp=timestamp
		# get cpu
		line=line[line.find("|")+1:]
		cpu=int(line[0:line.find(")")].strip())

		# write cpu definition
		if cpu not in wstream_cpu.keys():
			stack_depth[cpu]=0
			wstream_cpu[cpu]=OTF_WStream_open(otfname+"_cpu", cpu+1, manager_cpu)
			processes[cpu]=cpu+1
	
		# get processname and initialize function group and stream for process 
		line=line[line.find(")")+1:]
		processname=line[0:line.find("|")].strip()
		if processname not in process_functions.keys():
			processes[processname] = lpid
			OTF_WStream_writeDefProcess(global_wstream_processes, lpid, processname, 0)
			wstream_processes[processname]=OTF_WStream_open(otfname+"_processes", lpid, manager_processes)
			stack_depth[processname]=0
			process_functions[processname] = {}
			process_functions[processname]["Unknown"] = lfid
			OTF_WStream_writeDefFunctionGroup(global_wstream_cpu, lpid, processname)
			OTF_WStream_writeDefFunction(global_wstream_cpu, lfid, "Unknown", processes[processname],  0)
			lpid = lpid + 1
			lfid = lfid + 1

		# get duration
		line=line[line.find("|")+1:]
		duration=0.0
		has_duration=False
		if line.strip().endswith(";"):
			if (line.strip().startswith("!")):
				duration=float(line[line.find("!")+1:line.find("us")]);
				has_duration=True
			elif (line.strip().startswith("+")):
				duration=float(line[line.find("+")+1:line.find("us")]);
				has_duration=True
			else:
				duration=float(line[0:line.find("us")]);
				has_duration=True
		if has_duration:
			duration=duration*1000.0

		# get stack depth
		line=line[line.find("|")+1:]
		# the rest of line is 2 spaces + 2 spaces for stack depth + function name or }
		read_stack_depth=0
		line=line[2:]
		while line.startswith("  "):
			read_stack_depth=read_stack_depth+1
			line=line[2:]

		# correct stack depth for cpus
		while stack_depth[cpu]<read_stack_depth:
			OTF_WStream_writeEnter(wstream_cpu[cpu], timestamp, process_functions[processname]["Unknown"], processes[cpu], 0)
			stack_depth[cpu]=stack_depth[cpu]+1
		
		while stack_depth[cpu]>read_stack_depth:
			OTF_WStream_writeLeave(wstream_cpu[cpu], timestamp,process_functions[processname]["Unknown"], processes[cpu], 0)
			stack_depth[cpu]=stack_depth[cpu]-1
		

		#correct stack depth for process
		while stack_depth[processname]<read_stack_depth:
			OTF_WStream_writeEnter(wstream_processes[processname], timestamp, process_functions["Kernel"]["Unknown"], processes[processname], 0)
			stack_depth[processname]=stack_depth[processname]+1
		
		while stack_depth[processname]>read_stack_depth:
			OTF_WStream_writeLeave(wstream_processes[processname], timestamp,process_functions["Kernel"]["Unknown"], processes[processname], 0)
			stack_depth[processname]=stack_depth[processname]-1
		
		# now the rest of line can be function(); or
		# block (){ or
		# } (some trailer)
		function="Unknown"
		if (line.find("()")!=-1):
			function=line[0:line.find("()")].strip()
			if function not in process_functions[processname].keys():
				process_functions[processname][function] = lfid
				OTF_WStream_writeDefFunction(global_wstream_cpu, lfid, function, processes[processname],  0)
				lfid = lfid + 1
			if function not in process_functions["Kernel"].keys():
				process_functions["Kernel"][function] = lfid
				OTF_WStream_writeDefFunction(global_wstream_processes, lfid, function, processes["Kernel"],  0)
				lfid = lfid + 1
			

		#if line.strip().startswith("}"):
			# this is handled with per_cpu_depth

		# function start
		if line.strip().endswith("{"):
			OTF_WStream_writeEnter(wstream_cpu[cpu], timestamp, process_functions[processname][function], processes[cpu], 0)
			OTF_WStream_writeEnter(wstream_processes[processname], timestamp, process_functions["Kernel"][function], processes[processname], 0)
			stack_depth[cpu]=stack_depth[cpu]+1
			stack_depth[processname]=stack_depth[processname]+1

			wrote_data[processname]=True
			wrote_data[cpu]=True

		# function start and end
		if line.endswith("();"):
			OTF_WStream_writeEnter(wstream_cpu[cpu], timestamp, process_functions[processname][function], processes[cpu], 0)
			OTF_WStream_writeLeave(wstream_cpu[cpu], timestamp+int(duration), process_functions[processsname][function], processes[cpu], 0)
			OTF_WStream_writeEnter(wstream_processes[processname], timestamp, process_functions["Kernel"][function], processes[processname], 0)
			OTF_WStream_writeLeave(wstream_processes[processname], timestamp+int(duration), process_functions["Kernel"][function], processes[processname], 0)

			wrote_data[processname]=True
			wrote_data[cpu]=True



	#############################################################
	#
	# Process switch
	# Example:
	# 0)    <idle>-0    =>  acrorea-4301
	#############################################################
	elif re.match(".+\).+=>.*",line):

		# reset cpu stack
		cpu=int(line[0:line.find(")")].strip())
		for i in range(0,stack_depth[cpu]):
			OTF_WStream_writeLeave(wstream_cpu[cpu], timestamp, process_functions[processname]["Unknown"], processes[cpu], 0)
			stack_depth[cpu]=stack_depth[cpu]-1

		# TODO rebuild the stack for the new process
		# the stack is the same. it just now belongs to the other task

		# the same for processes
		processname =line[line.find(")")+1:line.find("=>")].strip()
		for i in range(0,stack_depth[processname]):
			OTF_WStream_writeLeave(wstream_processes[processname], timestamp, process_functions["Kernel"]["Unknown"], processes[processname], 0)
			stack_depth[processname]=stack_depth[processname]-1
	
	# empty line
	elif len(line.strip())==0:
		pass
	else:
		print "Not handled:"
		print line
		print "------------------------------"

	nr=nr+1
	if (nr%10000)==0:
		print nr
#	if nr==500000:
#		break

for key in wstream_cpu.keys():
	for i in range(0,stack_depth[key]):
		OTF_WStream_writeLeave(wstream_cpu[key], old_timestamp, process_functions["Kernel"]["Unknown"], processes[key], 0)
	OTF_WStream_close(wstream_cpu[key])

master_cpu = OTF_MasterControl_new(manager_cpu)


keys = wstream_cpu.keys()
keys.sort()

for cpu in keys:
	if cpu in wrote_data:
		OTF_WStream_writeDefProcess(global_wstream_cpu, processes[cpu], "CPU %d"%(cpu), 0)
		OTF_MasterControl_append(master_cpu, processes[cpu],processes[cpu])

OTF_MasterControl_write(master_cpu, otfname+"_cpu")
OTF_MasterControl_close(master_cpu)
OTF_WStream_close(global_wstream_cpu)
OTF_FileManager_close(manager_cpu)


for key in wstream_processes.keys():
	for i in range(0,stack_depth[key]):
		OTF_WStream_writeLeave(wstream_processes[key], old_timestamp, process_functions[key]["Unknown"], processes[key], 0)
	OTF_WStream_close(wstream_processes[key])

master_processes = OTF_MasterControl_new(manager_processes)

for key in wstream_processes.keys():
	if key in wrote_data:
		OTF_MasterControl_append(master_processes, processes[key],processes[key])

OTF_MasterControl_write(master_processes, otfname+"_processes")
OTF_MasterControl_close(master_processes)
OTF_WStream_close(global_wstream_processes)
OTF_FileManager_close(manager_processes)
